Newer Version Available

This content describes an older version of this product. View Latest

Reference

The following table lists supported REST resources in the API and provides a brief description for each. In each case, the URI for the resource follows the base URI, which you retrieve from the authentication service: http://domain/services/data. domain is your My Domain login URL or the instanced URL for your Salesforce org. For example, to retrieve basic information about an Account object in version 52.0: https://MyDomainName.my.salesforce.com/services/data/v52.0/sobjects/Account/ or https://yourInstance.my.salesforce.com/services/data/52.0/sobjects/Account/.

Click a call name to see syntax, usage, and more information for that call.

Resource Name URI and Description
Versions

/

Lists summary information about each Salesforce version currently available, including the version, label, and a link to each version's root.
Resources by Version

/vXX.X/

Lists available resources for the specified API version, including resource name and URI.
Limits

/vXX.X/limits/

Lists information about limits in your org. For each limit, this resource returns the maximum allocation and the remaining allocation based on usage.
Describe Global

/vXX.X/sobjects/

Lists the available objects and their metadata for your organization’s data.
sObject Basic Information

/vXX.X/sobjects/sObject/

Describes the individual metadata for the specified object. Can also be used to create a new record for a given object.
sObject Describe

/vXX.X/sobjects/sObject/describe/

Completely describes the individual metadata at all levels for the specified object.
sObject Get Deleted

/vXX.X/sobjects/sObject/deleted/​​​?start=startDateAndTime&end=endDateAndTime

Retrieves the list of individual records that have been deleted within the given timespan for the specified object.
sObject Get Updated

/vXX.X/sobjects/sObject/updated/​​​?start=startDateAndTime&end=endDateAndTime

Retrieves the list of individual records that have been updated (added or changed) within the given timespan for the specified object.
sObject Named Layouts

/vXX.X/sobjects/sObject/describe/namedLayouts/layoutName

Retrieves information about alternate named layouts for a given object.
sObject Rich Text Image Retrieve

/vXX.X/sobjects/sObject/id​/richTextImageFields/fieldName/contentReferenceId

Retrieves the specified image data from a specific rich text area field in a given record.
sObject Rows

/vXX.X/sobjects/sObject/id/

Accesses records based on the specified object ID. Retrieves, updates, or deletes records. This resource can also be used to retrieve field values.
sObject Rows by External ID

/vXX.X/sobjects/sObject/fieldName/fieldValue

Creates new records or updates existing records (upserts records) based on the value of a specified external ID field. Use the PATCH method to upsert a record with an external ID. Upsert uses the value of the external ID to determine whether to create a new record or update the existing one.
sObject ApprovalLayouts

/services/data/vXX.X/sobjects/sObject/describe/approvalLayouts/

Returns a list of approval layouts for a specified object.
sObject CompactLayouts

/services/data/vXX.X/sobjects/sObject/describe/compactLayouts/

Returns a list of compact layouts for a specific object.
Describe Layouts

/vXX.X/sobjects/Global/describe/layouts/

/vXX.X/sobjects/sObject/describe/layouts/

Returns a list of global publisher layouts and descriptions. You can request descriptions for a specific object or for all publisher layouts. Layout names and a list of fields are returned. Global publisher layouts customize the actions on global pages (like the Home page). In Lightning Experience, these layouts populate the Global Actions menu.
sObject PlatformAction

/vXX.X/sobjects/PlatformAction

PlatformAction is a virtual read-only object. It enables you to query for actions displayed in the UI, given a user, a context, device format, and a record ID. Examples include standard and custom buttons, quick actions, and productivity actions.
Lightning Toggle Metrics

/vXX.X/sobjects/LightningToggleMetrics

Return details about users who switched between Salesforce Classic and Lightning Experience.

Lightning Usage by App Type

/vXX.X/sobjects/LightningUsageByAppTypeMetrics

Return the total number of Lightning Experience and Salesforce Mobile users.
Lightning Usage by Browser

/vXX.X/sobjects/LightningUsageByBrowserMetrics

Return Lightning Experience usage results grouped by browser instance.
Lightning Usage by Page

/vXX.X/sobjects/LightningUsageByPageMetrics

Represents standard pages users viewed most frequently in Lightning Experience.
Lightning Usage by FlexiPage

/vXX.X/sobjects/LightningUsageByFlexiPageMetrics

Return details about the custom pages viewed most frequently in Lightning Experience.
Lightning Exit by Page Metrics

/vXX.X/sobjects/LightningUsageByFlexiPageMetrics

Return frequency metrics about the standard pages within which users switched from Lightning Experience to Salesforce Classic.
sObject Relationships

/vXX.X/sobjects/sObject/id/relationshipName

Accesses records by traversing object relationships via friendly URLs. You can retrieve, update, or delete the record associated with the traversed relationship field. If there are multiple related records, you can retrieve the complete set of associated records.
sObject Blob Retrieve

/vXX.X/sobjects/sObject/id/blobField

Retrieves the specified blob field from an individual record.
sObject Quick Actions

/vXX.X/sobjects/sObject/quickActions/

/vXX.X/sobjects/sObject/quickActions/actionName

/vXX.X/sobjects/sObject/quickActions/actionName/describe/

/vXX.X/sobjects/sObject/quickActions/actionName/defaultValues/

/vXX.X/sobjects/sObject/quickActions/actionName/defaultValues/parentId

Returns a list of actions and their details.
sObject Suggested Articles

/services/data/vXX.X/sobjects/sObject/suggestedArticles​?language=articleLanguage&subject=subject&description=description

/services/data/vXX.X/sobjects/sObject/ID/suggestedArticles?language=articleLanguage

Returns a list of suggested Salesforce Knowledge articles for a case, work order, or work order line item.
sObject User Password

/vXX.X/sobjects/User/userId/password

/vXX.X/sobjects/SelfServiceUser/selfServiceUserId/password

Set, reset, or get information about a user password.
Platform Event Schema by Event Name /services/data/vXX.X/sobjects/eventName/eventSchema

Gets the definition of a platform event in JSON format for an event name.

Platform Event Schema by Schema ID /services/data/vXX.X/event/eventSchema/schemaId

Gets the definition of a platform event in JSON format for a schema ID.

AppMenu

/services/data/vXX.X/appMenu/AppSwitcher/

/services/data/vXX.X/appMenu/Salesforce1/

Returns a list of items in either the Salesforce app drop-down menu or the Salesforce for Android, iOS, and mobile web navigation menu.
Compact Layouts

/vXX.X/compactLayouts?q=objectList

Returns a list of compact layouts for multiple objects.
Invocable Actions /services/data/vXX.X/actions/standard

/services/data/vXX.X/actions/custom

Use actions to add more functionality to your applications. Choose from standard actions, such as posting to Chatter or sending email, or create actions based on your company’s needs.

Parameterized Search

/services/data/vXX.X/parameterizedSearch/?q=searchString

Executes a simple RESTful search using parameters instead of a SOSL clause. Indicate parameters in a URL in the GET method. Or, use POST for more complex JSON searches.
Process Approvals

/services/data/vXX.X/process/approvals/

Returns a list of all approval processes. Can also be used to submit a particular record if that entity supports an approval process and one has already been defined. Records can be approved and rejected if the current user is an assigned approver.
Process Rules

/services/data/vXX.X/process/rules/

Returns a list of all active workflow rules. If a rule has actions, the actions will be listed under the rule. Can also be used to trigger all workflow rules that are associated with a specified record. The actions for a rule are only fired if the rule’s criteria is met.
Query

/vXX.X/query/?q=soql

This API resource executes the specified SOQL query.
QueryAll

/vXX.X/queryAll/?q=soql

Executes the specified SOQL query. Results can include deleted, merged and archived records.
Quick Actions

/vXX.X/quickActions/

Return a list of global quick actions and their types, as well as custom fields and objects that appear in the Chatter feed.
Recently Viewed Items

/vXX.X/recent

Gets the most recently accessed items that were viewed or referenced by the current user.
Record Count

/vXX.X/limits/recordCount

Lists information about object record counts in your organization.
Relevant Items

/vXX.X/sobjects/relevantItems

Gets the current user’s most relevant items. Relevant items include records for objects in the user’s global search scope and also most recently used (MRU) objects.
Salesforce Surveys Translation Resources

/vXX.X/localizedvalue/

Use REST APIs to translate survey fields, view, update, or delete translated survey fields. The translated values of surveys fields are stored in Flow fields.

Search

/vXX.X/search/?q=sosl

Executes the specified SOSL search. The search string must be URL-encoded.
Search Scope and Order

/vXX.X/search/scopeOrder

Returns an ordered list of objects in the default global search scope of a logged-in user. Global search keeps track of which objects the user interacts with and how often and arranges the search results accordingly. Objects used most frequently appear at the top of the list.
Search Result Layouts

/vXX.X/searchlayout/?q=commaDelimitedObjectList

Returns search result layout information for the objects in the query string. For each object, this call returns the list of fields displayed on the search results page as columns, the number of rows displayed on the first page, and the label used on the search results page.
Search Suggested Article Title Matches

/services/data/vXX.X/search/suggestTitleMatches?q=searchString​&language=articleLanguage&publishStatus=articlePublicationStatus

Returns a list of Salesforce Knowledge article titles that match the user’s search query string. Provides a shortcut to navigate directly to likely relevant articles before the user performs a search.
Search Suggested Queries

/services/data/vXX.X/search/suggestSearchQueries?q=searchString​&language=languageOfQuery

Returns a list of suggested searches based on the user’s query string text matching searches that other users have performed in Salesforce Knowledge. Provides a way to improve search effectiveness, before the user performs a search.
Tabs

/vXX.X/tabs

Returns a list of all tabs—including Lightning page tabs—available to the current user, regardless of whether the user has chosen to hide tabs via the All Tabs (+) tab customization feature.
Themes

/vXX.X/theme

Gets the list of icons and colors used by themes in the Salesforce application.

Composite Resources

Resource Name URI
Composite

/vXX.X/composite

Executes a series of REST API requests in a single call. You can use the output of one request as the input to a subsequent request. The response bodies and HTTP statuses of the requests are returned in a single response body. The entire series of requests counts as a single call toward your API limits.
Batch

/vXX.X/composite/batch

Executes up to 25 subrequests in a single request.
sObject Tree

/vXX.X/composite/tree

Creates one or more sObject trees with root records of the specified type. An sObject tree is a collection of nested, parent-child records with a single root record.
sObject Collections

The URI to use depends on the operation.

Create
POST /vXX.X/composite/sobjects
Retrieve
GET /vXX.X/composite/sobjects/sObject​?ids=recordId,recordId&fields=fieldname,fieldname
Update
PATCH /vXX.X/composite/sobjects
Delete
DELETE /vXX.X/composite/sobjects?ids=recordId,recordId
Executes actions on multiple records in one request. Use sObject Collections to reduce the number of round-trips between the client and server. The response bodies and HTTP statuses of the requests are returned in a single response body. The entire request counts as a single call toward your API limits.